Index: src/org/jboss/tools/deltacloud/ui/commands/StartInstanceHandler.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/StartInstanceHandler.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/StartInstanceHandler.java	(working copy)
@@ -24,9 +24,10 @@
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.jboss.tools.common.log.StatusFactory;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
+import org.jboss.tools.deltacloud.core.DeltaCloudResourceAction;
 import org.jboss.tools.deltacloud.ui.Activator;
 import org.jboss.tools.deltacloud.ui.views.CVMessages;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 /**
  * @author Andre Dietisheim
@@ -44,7 +45,7 @@
 		try {
 			if (selection instanceof IStructuredSelection) {
 				if (isSingleInstanceSelected(selection)) {
-					DeltaCloudInstance cvinstance = UIUtils.getFirstAdaptedElement(selection, DeltaCloudInstance.class);
+					DeltaCloudInstance cvinstance = WorkbenchUtils.getFirstAdaptedElement(selection, DeltaCloudInstance.class);
 					startInstance(cvinstance);
 				} else {
 					startWithDialog((IStructuredSelection) selection);
@@ -61,10 +62,10 @@
 
 	@SuppressWarnings("unchecked")
 	private void startWithDialog(IStructuredSelection selection) {
-		List<DeltaCloudInstance> deltaCloudInstances =  UIUtils.adapt((List<DeltaCloudInstance>) selection.toList(), DeltaCloudInstance.class);
+		List<DeltaCloudInstance> deltaCloudInstances =  WorkbenchUtils.adapt((List<DeltaCloudInstance>) selection.toList(), DeltaCloudInstance.class);
 		List<DeltaCloudInstance> stoppedInstances = getStoppedInstances(deltaCloudInstances);
 		DeltaCloudInstanceDialog dialog = new DeltaCloudInstanceDialog(
-					UIUtils.getActiveShell()
+				WorkbenchUtils.getActiveShell()
 					, stoppedInstances
 					, CVMessages.getString(START_INSTANCES_DIALOG_TITLE)
 					, CVMessages.getString(START_INSTANCES_DIALOG_MSG));
@@ -95,7 +96,7 @@
 		if (instance != null) {
 			executeInstanceAction(
 					instance
-					, DeltaCloudInstance.Action.START
+					, DeltaCloudResourceAction.START
 					, DeltaCloudInstance.State.RUNNING
 					, CVMessages.getString(STARTING_INSTANCE_TITLE)
 					, CVMessages.getFormattedString(STARTING_INSTANCE_MSG, new String[] { instance.getName() }));
Index: src/org/jboss/tools/deltacloud/ui/preferences/AbstractPreferenceValue.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/preferences/AbstractPreferenceValue.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/ui/preferences/AbstractPreferenceValue.java	(revision 0)
@@ -0,0 +1,77 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.ui.preferences;
+
+import org.eclipse.core.runtime.preferences.InstanceScope;
+import org.osgi.service.prefs.BackingStoreException;
+import org.osgi.service.prefs.Preferences;
+
+/**
+ * @author Andre Dietisheim
+ */
+public abstract class AbstractPreferenceValue<TYPE> {
+
+	private String pluginId;
+	private String prefsKey;
+
+	public AbstractPreferenceValue(String prefsKey, String pluginId) {
+		this.pluginId = pluginId;
+		this.prefsKey = prefsKey;
+	}
+
+	public abstract TYPE get();
+	
+	protected String doGet() {
+		return doGet(null);
+	}
+	
+	public abstract TYPE get(TYPE currentValue);
+	
+	protected String doGet(String currentValue) {
+		if( currentValue == null || currentValue.equals("")) {
+			// pre-set with previously used
+			Preferences prefs = getPreferences(this.pluginId);
+			return prefs.get(prefsKey, "");
+		} else {
+			return currentValue;
+		}
+	}
+
+	public void remove() {
+		String prefsValue = doGet();
+		if (prefsValue == null
+				|| prefsValue == null) {
+			return;
+		}
+		store(null);
+	}
+	
+	public abstract void store(TYPE value);
+	
+	protected void doStore(String value) {
+		Preferences prefs = getPreferences(this.pluginId);
+		String prefsValue = prefs.get(prefsKey, "");
+		if (prefsValue == null 
+				|| prefsValue.equals("") 
+				|| !prefsValue.equals(value)) {
+			prefs.put(prefsKey, value);
+			try {
+				prefs.flush();
+			} catch (BackingStoreException bse) {
+				// intentionally ignore, non-critical
+			}
+		}
+	}
+
+	protected Preferences getPreferences(String pluginId) {
+		return new InstanceScope().getNode(pluginId);
+	}
+}
Index: src/org/jboss/tools/deltacloud/ui/views/cloudelements/ImageView.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloudelements/ImageView.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/views/cloudelements/ImageView.java	(working copy)
@@ -10,8 +10,11 @@
  *******************************************************************************/
 package org.jboss.tools.deltacloud.ui.views.cloudelements;
 
+import java.beans.PropertyChangeEvent;
+
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudImage;
+import org.jboss.tools.deltacloud.core.ICloudElementFilter;
 import org.jboss.tools.deltacloud.ui.IDeltaCloudPreferenceConstants;
 
 /**
@@ -26,7 +29,7 @@
 
 	@Override
 	protected String getSelectedCloudPrefsKey() {
-		return IDeltaCloudPreferenceConstants.LAST_CLOUD_IMAGE_VIEW;
+		return IDeltaCloudPreferenceConstants.CLOUD_LAST_IMAGE_KEY;
 	}
 
 	@Override
@@ -45,10 +48,23 @@
 	}
 
 	@Override
+	public void propertyChange(PropertyChangeEvent event) {
+		super.propertyChange(event);
+		if (DeltaCloud.PROP_IMAGES.equals(event.getPropertyName())) {
+			updateFilteredLabel();
+		}
+	}
+
+	@Override
 	protected void addPropertyChangeListener(DeltaCloud cloud) {
 		if (cloud != null) {
 			super.addPropertyChangeListener(cloud);
 			cloud.addPropertyChangeListener(DeltaCloud.PROP_IMAGES, this);
 		}
 	}
+
+	@Override
+	protected ICloudElementFilter<DeltaCloudImage> getFilter(DeltaCloud cloud) {
+		return cloud.getImageFilter();
+	}
 }
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/AbstractFilterPage.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/AbstractFilterPage.java	(revision 0)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/AbstractFilterPage.java	(revision 0)
@@ -0,0 +1,119 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.internal.deltacloud.ui.wizards;
+
+import org.eclipse.core.runtime.Assert;
+import org.eclipse.jface.fieldassist.ControlDecoration;
+import org.eclipse.jface.wizard.WizardPage;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.ModifyEvent;
+import org.eclipse.swt.events.ModifyListener;
+import org.eclipse.swt.events.SelectionAdapter;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Text;
+import org.jboss.tools.deltacloud.core.DeltaCloud;
+import org.jboss.tools.deltacloud.core.ICloudElementFilter;
+import org.jboss.tools.deltacloud.core.IFieldMatcher;
+import org.jboss.tools.deltacloud.ui.SWTImagesFactory;
+
+/**
+ * @author Jeff Johnston
+ * @author André Dietisheim
+ */
+public abstract class AbstractFilterPage extends WizardPage {
+
+	protected final static String EMPTY_RULE = "ErrorFilterEmptyRule.msg"; //$NON-NLS-1$
+	protected final static String INVALID_SEMICOLON = "ErrorFilterSemicolon.msg"; //$NON-NLS-1$
+
+	protected final static String DEFAULT_LABEL = "DefaultButton.label"; //$NON-NLS-1$
+
+	private DeltaCloud cloud;
+
+	public AbstractFilterPage(String name, String title, String description, DeltaCloud cloud) {
+		super(name);
+		this.cloud = cloud;
+		setTitle(title);
+		setDescription(description);
+		setImageDescriptor(SWTImagesFactory.DESC_DELTA_LARGE);
+		setPageComplete(false);
+	}
+
+	private ModifyListener textListener = new ModifyListener() {
+
+		@Override
+		public void modifyText(ModifyEvent e) {
+			validate();
+		}
+	};
+
+	private SelectionAdapter buttonListener = new SelectionAdapter() {
+		@Override
+		public void widgetSelected(SelectionEvent e) {
+			Button b = (Button) e.widget;
+			Text text = getTextWidget(b);
+			if (text != null) {
+				text.setText(ICloudElementFilter.ALL_MATCHER_EXPRESSION);
+			}
+		}
+	};
+
+
+	protected abstract Text getTextWidget(Button button);
+	
+	protected abstract void validate();
+	
+	protected String validate(Text text, ControlDecoration decoration, String formError) {
+		String error = null;
+		if (text.getText().length() == 0) {
+			error = WizardMessages.getString(EMPTY_RULE);
+		} else if (text.getText().contains(ICloudElementFilter.EXPRESSION_DELIMITER)) {
+			error = WizardMessages.getString(INVALID_SEMICOLON);
+		}
+		if (error != null) {
+			decoration.setDescriptionText(error);
+			decoration.show();
+			setPageComplete(false);
+			setErrorMessage(error);
+			return error;
+		} else {
+			return formError;
+		}
+	}
+
+	protected Label createRuleLabel(String text, Composite container) {
+		Label label = new Label(container, SWT.NULL);
+		label.setText(text);
+		return label;
+	}
+
+	protected Button createDefaultRuleButton(final Composite container) {
+		Button button = new Button(container, SWT.NULL);
+		button.setText(WizardMessages.getString(DEFAULT_LABEL));
+		button.addSelectionListener(buttonListener);
+		return button;
+	}
+
+	protected Text createRuleText(IFieldMatcher rule, final Composite container) {
+		Assert.isNotNull(rule, "Rule may not be null");
+
+		Text text = new Text(container, SWT.BORDER | SWT.SINGLE);
+		text.setText(rule.toString());
+		text.addModifyListener(textListener);
+		return text;
+	}
+
+	protected DeltaCloud getDeltaCloud() {
+		return cloud;
+	}
+}
#P org.jboss.tools.deltacloud-feature
Index: src/org/jboss/tools/internal/deltacloud/test/core/client/KeyDomUnmarshallingTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/core/client/KeyDomUnmarshallingTest.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/core/client/KeyDomUnmarshallingTest.java	(working copy)
@@ -21,11 +21,11 @@
 
 import javax.xml.bind.JAXBException;
 
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.HttpMethod;
 import org.jboss.tools.deltacloud.core.client.Key;
-import org.jboss.tools.deltacloud.core.client.KeyAction;
-import org.jboss.tools.deltacloud.core.client.unmarshal.KeyActionUnmarshaller;
+import org.jboss.tools.deltacloud.core.client.unmarshal.ActionUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.KeyUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.KeysUnmarshaller;
 import org.jboss.tools.internal.deltacloud.test.fakes.KeyResponseFakes;
@@ -41,9 +41,9 @@
 
 	@Test
 	public void keyActionMayBeUnmarshalled() throws MalformedURLException, JAXBException, DeltaCloudClientException {
-		KeyAction keyAction = new KeyAction();
+		Action<Key> keyAction = new Action<Key>();
 		ByteArrayInputStream inputStream = new ByteArrayInputStream(KeyActionResponse.keyActionResponse.getBytes());
-		new KeyActionUnmarshaller().unmarshall(inputStream, keyAction);
+		new ActionUnmarshaller<Key>().unmarshall(inputStream, keyAction);
 		assertNotNull(keyAction);
 		assertEquals(KeyActionResponse.name, keyAction.getName());
 		assertEquals(KeyActionResponse.url, keyAction.getUrl().toString());
@@ -61,7 +61,7 @@
 		assertEquals(new URL(KeyResponse.url), key.getUrl());
 		assertEquals(KeyResponse.pem, key.getPem());
 		assertEquals(1, key.getActions().size());
-		KeyAction action = key.getActions().get(0);
+		Action<Key> action = key.getActions().get(0);
 		assertNotNull(action);
 		assertEquals(KeyResponse.url, action.getUrl().toString());
 		assertEquals(KeyResponse.name, action.getName());
@@ -80,7 +80,7 @@
 		assertEquals(new URL(KeysResponse.url1), key.getUrl());
 		assertEquals(KeysResponse.pem1, key.getPem());
 		assertEquals(1, key.getActions().size());
-		KeyAction action = key.getActions().get(0);
+		Action<Key> action = key.getActions().get(0);
 		assertNotNull(action);
 		assertEquals(KeysResponse.url1, action.getUrl().toString());
 		assertEquals(KeysResponse.name1, action.getName());
Index: src/org/jboss/tools/internal/deltacloud/test/fakes/ServerFake.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/fakes/ServerFake.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/fakes/ServerFake.java	(working copy)
@@ -19,7 +19,7 @@
 
 public class ServerFake {
 
-	public static final int DEFAULT_PORT = 3002;
+	public static final int DEFAULT_PORT = 3003;
 	private ExecutorService executor;
 	private int port;
 	private String response;
Index: src/org/jboss/tools/internal/deltacloud/test/ui/preferences/StringsPreferenceValueTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/ui/preferences/StringsPreferenceValueTest.java	(revision 0)
+++ src/org/jboss/tools/internal/deltacloud/test/ui/preferences/StringsPreferenceValueTest.java	(revision 0)
@@ -0,0 +1,94 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.internal.deltacloud.test.ui.preferences;
+
+import static org.junit.Assert.assertEquals;
+
+import org.jboss.tools.deltacloud.ui.preferences.StringsPreferenceValue;
+import org.junit.Before;
+import org.junit.Test;
+
+/**
+ * @author André Dietisheim
+ */
+public class StringsPreferenceValueTest {
+
+	private static final char DELIMITER = ',';
+
+	private static class StringsPreferenceValueFake extends StringsPreferenceValue {
+
+		private String values = "";
+
+		public StringsPreferenceValueFake(char delimiter) {
+			super(delimiter, null, null);
+		}
+
+
+		@Override
+		protected void doStore(String value) {
+			this.values = value;
+		}
+
+		@Override
+		protected String doGet(String currentValue) {
+			if (currentValue == null || currentValue.equals("")) {
+				return values;
+			} else {
+				return currentValue;
+			}
+		}
+
+	}
+
+	private StringsPreferenceValue stringValues;
+
+	@Before
+	public void setUp() {
+		this.stringValues = new StringsPreferenceValueFake(DELIMITER);
+	}
+
+	@Test
+	public void canAddValues() {
+		stringValues.add("11");
+		stringValues.add("22");
+		assertEquals(2, stringValues.get().length);
+		stringValues.add("33");
+		assertEquals(3, stringValues.get().length);
+	}
+
+	@Test
+	public void identicalValueAreNotAdded() {
+		String value = "11";
+		stringValues.add(value);
+		stringValues.add(value);
+		assertEquals(1, stringValues.get().length);
+	}
+
+	@Test
+	public void canAddDelimiterValue() {
+		stringValues.add("11");
+		assertEquals(1, stringValues.get().length);
+		stringValues.add(DELIMITER + "");
+		assertEquals(2, stringValues.get().length);
+	}
+
+	@Test
+	public void delimiterValueIsReturnedCorrectly() {
+		stringValues.add("11");
+		assertEquals(1, stringValues.get().length);
+		String delimiterValue = DELIMITER + "";
+		stringValues.add(delimiterValue);
+		String[] values = stringValues.get();
+		assertEquals(2, values.length);
+		values[1] = delimiterValue;
+	}
+
+}
Index: META-INF/MANIFEST.MF
===================================================================
--- META-INF/MANIFEST.MF	(revision 29180)
+++ META-INF/MANIFEST.MF	(working copy)
@@ -7,6 +7,7 @@
 Require-Bundle: org.jboss.tools.deltacloud.core;bundle-version="0.0.1",
  org.eclipse.core.runtime;bundle-version="[3.6.0,4.0.0)",
  org.junit;bundle-version="[4.8.0,5.0.0)",
- org.jboss.tools.common;bundle-version="[3.2.0,4.0.0)"
+ org.jboss.tools.common;bundle-version="[3.2.0,4.0.0)",
+ org.jboss.tools.deltacloud.ui;bundle-version="0.1.0"
 Bundle-ClassPath: jruby-complete-1.5.3.jar,
  .
Index: src/org/jboss/tools/internal/deltacloud/test/core/client/InstanceDomUnmarshallingTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/core/client/InstanceDomUnmarshallingTest.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/core/client/InstanceDomUnmarshallingTest.java	(working copy)
@@ -20,10 +20,10 @@
 
 import javax.xml.bind.JAXBException;
 
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.Instance;
-import org.jboss.tools.deltacloud.core.client.InstanceAction;
-import org.jboss.tools.deltacloud.core.client.unmarshal.InstanceActionUnmarshaller;
+import org.jboss.tools.deltacloud.core.client.unmarshal.ActionUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.InstanceUnmarshaller;
 import org.jboss.tools.deltacloud.core.client.unmarshal.InstancesUnmarshaller;
 import org.jboss.tools.internal.deltacloud.test.fakes.InstanceResponseFakes.InstanceActionResponse;
@@ -38,9 +38,9 @@
 
 	@Test
 	public void instanceActionMayBeUnmarshalled() throws MalformedURLException, JAXBException, DeltaCloudClientException {
-		InstanceAction instanceAction = new InstanceAction();
+		Action<Instance> instanceAction = new Action<Instance>();
 		ByteArrayInputStream inputStream = new ByteArrayInputStream(InstanceActionResponse.response.getBytes());
-		new InstanceActionUnmarshaller().unmarshall(inputStream, instanceAction);
+		new ActionUnmarshaller<Instance>().unmarshall(inputStream, instanceAction);
 		assertNotNull(instanceAction);
 		assertEquals(InstanceActionResponse.name, instanceAction.getName());
 		assertEquals(InstanceActionResponse.url, instanceAction.getUrl().toString());
Index: src/org/jboss/tools/internal/deltacloud/test/DeltaCloudTestSuite.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/DeltaCloudTestSuite.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/DeltaCloudTestSuite.java	(working copy)
@@ -10,12 +10,14 @@
  ******************************************************************************/
 package org.jboss.tools.internal.deltacloud.test;
 
+import org.jboss.tools.internal.deltacloud.test.core.client.APIDomUnmarshallingTest;
 import org.jboss.tools.internal.deltacloud.test.core.client.HardwareProfileDomUnmarshallingTest;
 import org.jboss.tools.internal.deltacloud.test.core.client.ImageDomUnmarshallingTest;
 import org.jboss.tools.internal.deltacloud.test.core.client.InstanceDomUnmarshallingTest;
 import org.jboss.tools.internal.deltacloud.test.core.client.KeyDomUnmarshallingTest;
 import org.jboss.tools.internal.deltacloud.test.core.client.RealmDomUnmarshallingTest;
 import org.jboss.tools.internal.deltacloud.test.core.job.CloudSchedulingRulesTest;
+import org.jboss.tools.internal.deltacloud.test.ui.preferences.StringsPreferenceValueTest;
 import org.junit.runner.RunWith;
 import org.junit.runners.Suite;
 
@@ -29,6 +31,8 @@
 	InstanceDomUnmarshallingTest.class,
 	ImageDomUnmarshallingTest.class,
 	HardwareProfileDomUnmarshallingTest.class,
-	RealmDomUnmarshallingTest.class})
+	APIDomUnmarshallingTest.class,
+	RealmDomUnmarshallingTest.class,
+	StringsPreferenceValueTest.class})
 public class DeltaCloudTestSuite {
 }
Index: src/org/jboss/tools/internal/deltacloud/test/core/client/ServerTypeMockIntegrationTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/core/client/ServerTypeMockIntegrationTest.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/core/client/ServerTypeMockIntegrationTest.java	(working copy)
@@ -19,6 +19,7 @@
 import java.util.Collections;
 import java.util.List;
 
+import org.jboss.tools.deltacloud.core.client.API.Driver;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudNotFoundClientException;
@@ -55,7 +56,7 @@
 
 	@Test
 	public void recognizesDeltaCloud() throws IOException {
-		assertEquals(DeltaCloudClientImpl.DeltaCloudServerType.MOCK, testSetup.getClient().getServerType());
+		assertEquals(Driver.MOCK, testSetup.getClient().getServerType());
 	}
 
 	/**
@@ -75,7 +76,7 @@
 		serverFake.start();
 		try {
 			assertEquals(
-					DeltaCloudClientImpl.DeltaCloudServerType.UNKNOWN,
+					Driver.UNKNOWN,
 					new DeltaCloudClientImpl(
 							MockIntegrationTestContext.SERVERFAKE_URL, MockIntegrationTestContext.DELTACLOUD_USER,
 							MockIntegrationTestContext.DELTACLOUD_PASSWORD).getServerType());
@@ -97,7 +98,7 @@
 			DeltaCloudClientImpl errorClient = new DeltaCloudClientImpl(MockIntegrationTestContext.DELTACLOUD_URL) {
 				@Override
 				public List<Image> listImages() throws DeltaCloudClientException {
-					requestStringResponse(new DeltaCloudRequest() {
+					request(new DeltaCloudRequest() {
 
 						@Override
 						public URL getUrl() throws MalformedURLException {
Index: src/org/jboss/tools/internal/deltacloud/test/core/DeltaCloudMockIntegrationTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/core/DeltaCloudMockIntegrationTest.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/core/DeltaCloudMockIntegrationTest.java	(working copy)
@@ -51,7 +51,7 @@
 	@Test
 	public void testConnectionReportsFalseOnAuthFailure() throws MalformedURLException, DeltaCloudClientException,
 			DeltaCloudException {
-		ServerFake serverFake = setupServerFake("HTTP/1.1 403 Forbidden\n\n\n");
+		ServerFake serverFake = setupServerFake("HTTP/1.1 401 Forbidden\n\n\n");
 		try {
 			DeltaCloud deltaCloud = new DeltaCloudFake(
 					"http://localhost:" + ServerFake.DEFAULT_PORT,
Index: src/org/jboss/tools/internal/deltacloud/test/core/client/InstanceMockIntegrationTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/core/client/InstanceMockIntegrationTest.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/core/client/InstanceMockIntegrationTest.java	(working copy)
@@ -24,6 +24,7 @@
 import java.util.List;
 import java.util.concurrent.ExecutionException;
 
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClient;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl;
@@ -31,9 +32,7 @@
 import org.jboss.tools.deltacloud.core.client.HttpMethod;
 import org.jboss.tools.deltacloud.core.client.Image;
 import org.jboss.tools.deltacloud.core.client.Instance;
-import org.jboss.tools.deltacloud.core.client.Instance.InstanceState;
-import org.jboss.tools.deltacloud.core.client.InstanceAction;
-import org.jboss.tools.deltacloud.core.client.InternalDeltaCloudClient;
+import org.jboss.tools.deltacloud.core.client.StateAware.State;
 import org.jboss.tools.internal.deltacloud.test.context.MockIntegrationTestContext;
 import org.junit.After;
 import org.junit.Before;
@@ -136,7 +135,7 @@
 			instance = testSetup.getClient().createInstance(image.getId());
 			assertTrue(instance != null);
 			assertEquals(image.getId(), instance.getImageId());
-			assertEquals(InstanceState.RUNNING, instance.getState());
+			assertEquals(State.RUNNING, instance.getState());
 		} finally {
 			testSetup.quietlyDestroyInstance(instance);
 		}
@@ -161,19 +160,17 @@
 	public void destroyThrowsExceptionOnUnknowInstanceId() throws DeltaCloudClientException, IllegalArgumentException,
 			InstantiationException, IllegalAccessException, InvocationTargetException, SecurityException,
 			NoSuchMethodException {
-		InternalDeltaCloudClient client = (InternalDeltaCloudClient) testSetup.getClient();
-		client.performInstanceAction(
+		DeltaCloudClient client = testSetup.getClient();
+		client.performAction(
 				createInstanceAction(
-						InstanceAction.DESTROY,
+						"destroy",
 						MockIntegrationTestContext.DELTACLOUD_URL,
 						HttpMethod.POST,
 						new Instance()));
 	}
 
-	private InstanceAction createInstanceAction(String name, String url, HttpMethod method, Instance instance)
-			throws IllegalArgumentException, InstantiationException, IllegalAccessException, InvocationTargetException,
-			SecurityException, NoSuchMethodException {
-		InstanceAction action = new InstanceAction();
+	private Action<Instance> createInstanceAction(String name, String url, HttpMethod method, Instance instance) {
+		Action<Instance> action = new Action<Instance>();
 		action.setName(name);
 		action.setMethod(method);
 		action.setOwner(instance);
@@ -202,31 +199,31 @@
 		DeltaCloudClient client = testSetup.getClient();
 		testInstance.stop(client);
 		testInstance = client.listInstances(testInstance.getId()); // reload!
-		assertEquals(InstanceState.STOPPED, testInstance.getState());
+		assertEquals(State.STOPPED, testInstance.getState());
 	}
 
 	@Test
 	public void canStartInstance() throws DeltaCloudClientException {
 		Instance testInstance = testSetup.getTestInstance();
 		DeltaCloudClient client = testSetup.getClient();
-		if (testInstance.getState() == InstanceState.RUNNING) {
+		if (testInstance.getState() == State.RUNNING) {
 			testInstance.stop(client);
 		}
 		testInstance.start(client);
 		testInstance = client.listInstances(testInstance.getId()); // reload!
-		assertEquals(InstanceState.RUNNING, testInstance.getState());
+		assertEquals(State.RUNNING, testInstance.getState());
 	}
 
 	@Test
 	public void canStartInstanceByAction() throws DeltaCloudClientException {
 		Instance testInstance = testSetup.getTestInstance();
 		DeltaCloudClient client = testSetup.getClient();
-		if (testInstance.getState() == InstanceState.RUNNING) {
+		if (testInstance.getState() == State.RUNNING) {
 			testInstance.stop(client);
 		}
 		assertTrue(testInstance.start(client));
 		testInstance = client.listInstances(testInstance.getId()); // reload!
-		assertEquals(InstanceState.RUNNING, testInstance.getState());
+		assertEquals(State.RUNNING, testInstance.getState());
 	}
 
 	@Test
@@ -254,7 +251,7 @@
 		Instance testInstance = testSetup.getTestInstance();
 		DeltaCloudClient client = testSetup.getClient();
 		testInstance = client.listInstances(testInstance.getId()); // reload
-		assertTrue(testInstance.getState() == InstanceState.RUNNING);
+		assertTrue(testInstance.getState() == State.RUNNING);
 		assertFalse(testInstance.destroy(client));
 	}
 
@@ -266,7 +263,7 @@
 		try {
 			testInstance.stop(client);
 			testInstance = client.listInstances(testInstance.getId()); // reload
-			assertTrue(testInstance.getState() == InstanceState.STOPPED);
+			assertTrue(testInstance.getState() == State.STOPPED);
 			assertFalse(testInstance.reboot(client));
 		} finally {
 			testInstance.start(client);
Index: src/org/jboss/tools/internal/deltacloud/test/core/client/KeyMockIntegrationTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/core/client/KeyMockIntegrationTest.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/core/client/KeyMockIntegrationTest.java	(working copy)
@@ -10,6 +10,7 @@
  ******************************************************************************/
 package org.jboss.tools.internal.deltacloud.test.core.client;
 
+import static org.junit.Assert.*;
 import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertNotNull;
 import static org.junit.Assert.assertThat;
@@ -20,6 +21,7 @@
 
 import org.hamcrest.BaseMatcher;
 import org.hamcrest.Description;
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClient;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl;
@@ -89,8 +91,8 @@
 		Key key = client.createKey(id);
 		assertNotNull(key);
 		assertEquals(id, key.getId());
-		client.deleteKey(id);
-		client.listKey(id);
+		key.destroy(client);
+		client.listKey(key.getId());
 	}
 
 	/**
@@ -155,7 +157,9 @@
 
 	private void quietlyDeleteKey(String id) {
 		try {
-			testSetup.getClient().deleteKey(id);
+			DeltaCloudClient client = testSetup.getClient();
+			Key key = client.listKey(id);
+			key.destroy(client);
 		} catch (Exception e) {
 			// ignore
 		}
